﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Handler class - chart.bas
'Populate the data for the google chart with two gauges.
'Google Gauge:
'https://developers.google.com/chart/interactive/docs/gallery/gauge#overview
Sub Class_Globals      
'No globals
End Sub

Public Sub Initialize
'Not used
End Sub

Public Sub Handle(req As ServletRequest, resp As ServletResponse)
	'Log("DHT11GoogleLineChart :: Draw Chart")	
	resp.ContentType = "application/json"
	'Define cols and rows. 1 = Temp, 2 = Hum
	Dim cols1 As List
	cols1.Initialize
	Dim rows1 As List
	rows1.Initialize
	Dim cols2 As List
	cols2.Initialize
	Dim rows2 As List
	rows2.Initialize
	'Create the chartdata with the two sets of data
	CreateChartData(cols1, rows1, cols2, rows2)
	'Set the options for the two gauges
	Dim options1 As Map
	options1.Initialize
	Dim options2 As Map
	options2.Initialize
	CreateChartOptions(options1, options2)
	'Write the response back to the requestor
	Dim jg As JSONGenerator
	jg.Initialize(CreateMap("data1": CreateMap ("cols": cols1, "rows": rows1), "data2": CreateMap ("cols": cols2, "rows": rows2), "options1": options1, "options2":options2, "lastupdate":DateTime.Time(DateTime.Now)))
	resp.Write(jg.ToString)
	'Log(jg.ToPrettyString(2))
End Sub

'
Private Sub CreateColumn(id As String, Label As String, dataType As String) As Map
	Return CreateMap("id": id, "label": Label, "type": dataType)
End Sub

Private Sub CreateRow(Values As List) As Map
	Dim vr As List
	vr.Initialize
	For Each o As Object In Values
		vr.Add(CreateMap("v": "" & o & ""))
		'vr.Add(CreateMap("v": o))
	Next
	Return CreateMap("c": vr)
End Sub

Private Sub CreateChartData(cols1 As List, rows1 As List, cols2 As List, rows2 As List)
	'Log("CreateLineChartData :: Start")
	cols1.Add(CreateColumn("", "Temp", "number"))
	cols2.Add(CreateColumn("", "Hum", "number"))
	'celcius pressure
	Dim l As List = File.ReadList(File.DirApp, Main.chartdatafile)
	'Log("Data Entries to load = " & l.Size)
	For i = 0 To l.Size - 1
		Dim s() As String = Regex.Split(";", l.Get(i))
		If s.Length = 2 Then
			'take only the first entry of the data file (which is the most actual data)
			If i = 0 Then 
				rows1.Add(CreateRow(Array As Object(s(0))))
				rows2.Add(CreateRow(Array As Object(s(1))))
			End If
		End If
	Next
	'Log("CreateLineChartData :: End")
End Sub

Private Sub CreateChartOptions (options1 As Map, options2 As Map)
	'Temp
	options1.Put("min", -10)
	options1.Put("max", 40)
	options1.Put("yellowFrom",30)
	options1.Put("yellowTo",35)
	options1.Put("redFrom", 35)
	options1.Put("redTo",40)
	options1.Put("minorTicks",5)
	options1.Put("greenColor","#CCFFCC")
    options1.Put("yellowColor","#FFFFCC")
    options1.Put("redColor","#F78181")
	'Hum
	options2.Put("min", 10)
	options2.Put("max", 100)
	options2.Put("greenFrom", 30)
	options2.Put("greenTo",60)
	options2.Put("minorTicks",10)
	options2.Put("greenColor","#CCFFCC")
    options2.Put("yellowColor","#FFFFCC")
    options2.Put("redColor","#F78181")
End Sub
